gramoowodd(w,l) = {
  my(caJ);
  caJ = cache_J(l, 2*w);
  return(matrix((w+1)/2, (w+1)/2, u, v,\
                biloo_cache([0,0,2*u-1], [0,0,2*v-1], caJ)));
};

triodd(M) = {
  my(RES);
  RES=[];
  for(j=1, matsize(M)[2],
    if(sum(i=1,matsize(M)[1],M[i,j]+abs(M[i,j]))\
       *sum(i=1,matsize(M)[1],M[i,j]-abs(M[i,j]))==0,
       RES = concat(RES,[j])));
   return(abs(vecextract(M,RES)));
};

convertodd(M) = {
  my(u);
  u = vector(#M,j,[0,0]);
  for(k=1, #M,
    for(i=1, #(M~),
      u[k] = concat(u[k],vector(abs(M[i,k]),j,2*i-1))));
  return(u);
};

n1mat(M) = vecmax(vector(matsize(M)[2],j,sum(i=1,matsize(M)[1],M[i,j])));

gramooweven(w,l) = {
  my(caJ);
  caJ = cache_J(l, 2*w+1);
  return(matrix(w/2+2, w/2+2, u, v,\
                if((u<(w/2+1))&&(v<(w/2+1)),
                   biloo_cache([0,0,2*u], [0,0,2*v], caJ),
                if((u>w/2)&&(v>w/2),
                if(u==v, triv(l),
                   eps(l)),
                   J(min(2*u,2*v),l)))));
};

trieven(M) = {
  my(RES);
  RES=[];
  for(j=1, matsize(M)[2],
    if((sum(i=1,matsize(M)[1],M[i,j]+abs(M[i,j]))*sum(i=1,matsize(M)[1],M[i,j]-abs(M[i,j]))==0)&&(sum(i=1,matsize(M)[1]-2,Mod(M[i,j],2))==Mod(M[matsize(M)[1],j],2)), RES=concat(RES,[j]))); abs(vecextract(M,RES)
  );
};

converteven(M) = {
  my(u);
  u=vector(#M,j,[M[#(M~)-1,j],M[#(M~),j]]);
  for(k=1, #M,
    for(i=1, #(M~)-2 ,
      u[k] = concat(u[k],vector(abs(M[i,k]),j,2*i));
    );
  );
  return(u);
};


liste_qfminim(l, w, mult) = {
  if(w%2==1,
    select(x->(x[#x]==w),convertodd(triodd(qfminim(gramoowodd(w,l),Phi0(l)*1.001/mult,,2)[3])));
  ,
    select(x->(x[#x]==w),converteven(trieven(qfminim(gramooweven(w,l),Phi0(l)*1.001/mult,,2)[3])));
  );
};


liste_connue(w)=select(x->(x[1][#x[1]]<=w),ex_poids_connus_nontrie());

select_m1(v)=select(x->(x[#x]>x[#x-1]),v);

CFnorminit(v,l)={my(caJ,boo,eperp,deltaglob);
	r=#v;
	caJ=cache_J(l,50);
	boo=sum(i=1,r,sum(j=1,r,v[i][1]*v[j][1]*biloo_cache(v[i][2],v[j][2],caJ)));
	eperp=sum(i=1,r,sum(j=1,r,v[i][1]*v[j][1]*v[i][3]*v[j][3]*(1-epsil(v[i][2],v[j][2]))/4));
	deltaglob=sum(i=1,r,v[i][1]^2/v[i][4]);
	return(deltaglob-boo/Phi0(l)-Phi12(l)*eperp/Phi0(l));
};

testtovec(w,d,m)={my(r,mask,v);
	r=#w[5];
	mask=vecextract(ex_poids_connus(),w[4]);	
	v=vector(r);
	for(i=1,r-1,v[i]=[w[5][i],mask[i][1],1,mask[i][2]]);
	v[r]=[w[5][r],w[1],d,m];
	return(v);};

CFnorm(test,l,m)=CFnorminit(testtovec(test,m==1,m),l);

CF(test,l,m)=Phi0(l)*CFnorm(test,l,m);
