wt_bounds = (12, 1, 2)
min_rank = 1
max_rank = 8

for n in range(min_rank, max_rank+1):
    print("Genus "+str(n)+":")
    dim_dict = {}
    for dw in it_dw_Sp(n, *wt_bounds):
        d = new_orth_odd_para_list[n][dw]
        if d!=0:
            dim_dict[dw] = [d, ["Oo"+str(tuple([dw[i]+n-i for i in range(n)]))
                                +" (new): "+str(d)]]
        else:
            dim_dict[dw] = [d, []]
    for global_para, archi_para, char_dict\
            in formal_global_Arthur_param_with_char_BC(n, 'Siegel'):
        for dw in it_dw_sub_Sp(archi_para, *wt_bounds):
            if Mod(sum(dw),2)!=0:
                continue
            endo_contrib_para, S = endo_contrib_Sp(
                n, dw, global_para, char_dict, new_sympl_para_list,
                new_orth_odd_para_list, new_orth_even_para_list, verbose=False,
                ret_str=True)
            if endo_contrib_para!=0:
                dim_dict[dw][0] += endo_contrib_para
                dim_dict[dw][1].append(S)
    for dw in it_dw_Sp(n, *wt_bounds):
        x = dim_dict[dw]
        if x[0]==0:
            continue
        print("weight "+str([dw[i]+1+n for i in range(n)])+": dim="+str(x[0]))
        for S in x[1]:
            print("  "+S)
    print('')

