\r without_GRH.gp
\r testfin.gp
\r qfminim_trie.gp
allocatemem(2^29);
\p 3
pc=ex_poids_connus();
to_cert=[];
addtocert(u,v)=concat(u,select(x->(x[3]<-0.00001),v));
tri(li)=select(x->(x[3]>-0.0001),li);

print("qfminim w=23, l=9.74, mult=2 : card")
lw23_mult2 = liste_qfminim(9.74, 23, 2);
print(#lw23_mult2);
li1 = vector(#lw23_mult2, i, [lw23_mult2[i], 0, 1000, 0, 0]);

print("for(i=1,10,li1 = testfin_liste(li1, 2+i, 2, pc[1..23],1,2));")
for(i=1,10,li1 = testfin_liste(li1, 2+i, 2, pc[1..23],1,2));
to_cert=addtocert(to_cert,li1); li2=tri(li1); 
print(#li2," elements remaining");

print("for(i=0,5,li2 = testfin_liste(li2, 7.0+i*.5, 2, pc[1..23],3,4));")
for(i=0,5,li2 = testfin_liste(li2, 7.0+i*.5, 2, pc[1..23],3,4));
to_cert=addtocert(to_cert,li2); li3=tri(li2); 
print(#li3," elements remaining");

print("The last 6 linear combinations found with negative CF are:");

for(i=1,6,print(testtovec(to_cert[#to_cert+1-i],0,2)," ",to_cert[#to_cert+1-i][3],"  CF: ",CF(to_cert[#to_cert+1-i],to_cert[#to_cert+1-i][2],2)))

print("li3=testfin_liste(li3, 11, 2, pc[1..23],5,5);");
li3=testfin_liste(li3, 11, 2, pc[1..23],5,5);
to_cert=addtocert(to_cert,li3); li4=tri(li3); 
print(#li4," elements remaining");

print("The last 2 linear combinations found with negative CF are:");
for(i=1,2,print(testtovec(to_cert[#to_cert+1-i],0,2)," ",to_cert[#to_cert+1-i][3],"  CF: ",CF(to_cert[#to_cert+1-i],to_cert[#to_cert+1-i][2],2)))

print("li4=testfin_liste(li4, 8.75, 2, pc[1..23],6,6);");
li4=testfin_liste(li4, 8.75, 2, pc[1..23],6,6);
to_cert=addtocert(to_cert,li4); li5=tri(li4); 
print(#li5," elements remaining");

print("The last linear combination found with negative CF is:");
for(i=1,1,print(testtovec(to_cert[#to_cert+1-i],0,2)," ",to_cert[#to_cert+1-i][3],"  CF: ",CF(to_cert[#to_cert+1-i],to_cert[#to_cert+1-i][2],2)))

print("li5=testfin_liste(li5, 11.75, 2, pc[1..23],6,6);");
li5=testfin_liste(li5, 11.75, 2, pc[1..23],6,6);
to_cert=addtocert(to_cert,li5); li6=tri(li5); 
print(#li6," elements remaining");

print("The last linear combination found with negative CF is:");
for(i=1,1,print(testtovec(to_cert[#to_cert+1-i],0,2)," ",to_cert[#to_cert+1-i][3],"  CF: ",CF(to_cert[#to_cert+1-i],to_cert[#to_cert+1-i][2],2)))


print("Remaining cases:")
for(i=1,2,print(li6[i][1]));

print("After a long search, we have been led to consider the following:");
print("good_part=vecextract(pc[1..23],5755521);");
good_part=vecextract(pc[1..23],5755521);
print("This is the following 11 element subset of pc[1..23]:");
print(good_part);
print("li7=testfin_liste([li6[1]], 10.25, 2, good_part);");
li7=testfin_liste([li6[1]], 10.25, 2, good_part,1,11);
print(li7[1]);
print("NB : it said 0 killed as -0.000575 >-0.001";)
print("the linear combination is:");
li7[1][4]=5755521;
print(testtovec(li7[1],0,2));
print("and we have CF=", CF(li7[1],li7[1][2],2));

to_cert=addtocert(to_cert,li7);

print("to certify with interval arithmetic : the qfminim and the ",#to_cert," linear combinations stored in the vector to_cert");

