Sp=[[[11/2], 1],[[15/2], 1],[[17/2], 1],[[19/2], 1],[[21/2], 1],[[23/2], 2],[[19/2, 7/2], 1],[[21/2, 5/2], 1],[[21/2, 9/2], 1],[[21/2, 13/2], 1],[[23/2, 7/2], 1],[[23/2, 9/2], 1],[[23/2, 13/2], 1],[[23/2, 13/2, 5/2], 1],[[23/2, 15/2, 3/2], 1],[[23/2, 15/2, 7/2], 1],[[23/2, 17/2, 5/2], 1],[[23/2, 17/2, 9/2], 1],[[23/2, 19/2, 3/2], 1],[[23/2, 19/2, 11/2], 1],[[23/2, 21/2, 17/2, 11/2, 3/2], 1]];

SOo=[[[], 1],[[11], 1],[[12, 8, 4], 1]];

SOe=[[[12, 9, 5, 2], 1],[[12, 10, 7, 1], 1]];

wmot(pi)=if(#pi[1]==0,0,2*pi[1][1]);
altos(pi)=lift(Mod(wmot(pi),2));

PiSp=vector(#Sp,u,[Sp[u][1],vecsort(concat(Sp[u][1],-Sp[u][1])),2*#Sp[u][1],wmot(Sp[u]),altos(Sp[u]),"S",Sp[u][2]]);
PiSOe=vector(#SOe,u,[SOe[u][1],vecsort(concat(SOe[u][1],-SOe[u][1])),2*#SOe[u][1],wmot(SOe[u]),altos(SOe[u]),"Oe",SOe[u][2]]);
PiSOo=vector(#SOo,u,[SOo[u][1],vecsort(concat([0],concat(SOo[u][1],-SOo[u][1]))),1+2*#SOo[u][1],wmot(SOo[u]),altos(SOo[u]),"Oo",SOo[u][2]]);
Pialg=vecsort(concat(concat(PiSOe,PiSOo),PiSp),[4,3]);

dmax(p,w)={my(delta,par,res);
if(Mod(#p,2)==Mod(1,2),res=1,
	delta=vecmin(vector(#p-1,u,p[u+1]-p[u]));
	res=vecmin([w-2*p[#p]+1,delta]);
	if(Mod(2*p[1]+res-1,2)==Mod(1,2),res=res-1);
);
res}

makePidisc(w)={my(da,db,res);
da=vector(#Pialg,u,dmax(Pialg[u][2],w));
db=vector(#Pialg,u,floor((da[u]+1)/2));
res=vector(#Pialg,u,if(db==0,[],vector(db[u],v,[u,da[u]+2-2*v])));
concat(res)
}

tot=makePidisc(24);

poids(i,d)={
my(p,vecun,res);
p=Pialg[i][2];
vecun=vector(#p,u,1);
res=[];
for(i=0,d-1,res=concat(res,p+(1-d+2*i)/2*vecun));
vecsort(res)}

poidspar(par)=vecsort(concat(vector(#par,u,poids(par[u][1],par[u][2]))));

reg(poids)=1-0^prod(i=1,#poids-1,poids[i+1]-poids[i]);

adm(par)=reg(poidspar(par));

par(liste)=vector(#liste,i,tot[liste[i]]);


addpidisc(vecliste,num)={
my(res,listeprime);
res=vecliste;
for(i=1,#vecliste,listeprime=concat(vecliste[i],num);if(adm(par(listeprime)),res=concat(res,[listeprime])));
res}

res=[[]];
for(i=1,#tot,res=addpidisc(res,i));
res=vector(#res-1,i,res[i+1]);
diml(liste)=#poidspar(par(liste));
res=select(x->(Mod(diml(x),2)==Mod(1,2)),res);

epsilon(i,j)={
my(a,b,f,g);
a=Pialg[i];
b=Pialg[j];
if(a[5]==b[5],return(1));
if(a[5]==0,a=Pialg[j]; b=Pialg[i]);
f=1;
if(Mod(b[3],2)==Mod(1,2),f=prod(i=1,#a[1],I^(1+2*a[1][i])));
g=if(#b[1]==0,1,prod(i=1,#a[1],prod(j=1,#b[1],(-1)^(1+max(a[1][i]*2,b[1][j]*2)))));
f*g}

dimni(liste)=vector(#liste,u,lift(Mod(#poids(tot[liste[u]][1],tot[liste[u]][2]),2)));

epsilonpsi(liste)={my(s);
s=dimni(liste);
for(i=1,#s,if(s[i]==0,s[i]=prod(j=1,#s,epsilon(tot[liste[i]][1],tot[liste[j]][1])^(min(tot[liste[i]][2],tot[liste[j]][2])))));
s
}

signepi(i,p)={my(s,poids);
poids=Pialg[i][1];
s=Set(vector(ceil((#p+1)/2),i,p[2*i-1]));
(-1)^#setintersect(Set(poids),s)};


chisiegel(liste)={my(s,n,d,p);
p=poidspar(par(liste));
s=dimni(liste);
n=vector(#liste,u,Pialg[tot[liste[u]][1]][3]);
d=vector(#liste,u,tot[liste[u]][2]);
for(i=1,#s,if(s[i]==0,if((-1)^(d[i])==1,s[i]=(-1)^(n[i]*d[i]/4),s[i]=signepi(tot[liste[i]][1],p))));
s}

resAMF=select(x->(chisiegel(x)==epsilonpsi(x)),res);
final=vector(#resAMF,u,Vecrev(resAMF[u]));
final=vecsort(final,(x,y) -> (diml(x)-diml(y))); 

name(i,d)=concat([Pialg[i][6],Pialg[i][1],"[",d,"]+"]);
namepar(liste)=concat(vector(#liste,i,name(tot[liste[i]][1],tot[liste[i]][2])));

weight(poidsodddim)=vector((#poidsodddim-1)/2,u,-poidsodddim[u]+u);

for(i=1,#final,print(namepar(final[i]));print((diml(final[i])-1)/2);print(weight(poidspar(par(final[i])))));